-- Informatics 1 - Functional Programming
-- Competition - Draw an Interesting Picture with Haskell!
--
-- by Clemens Wolff (s0942284)
--
-- Week 9-10



-- ~~~/***** About *****\~~~
--
-- Being able to draw one picture in Haskell is good. Being able to draw all the pictures one could ever want to (sort of) is better!
-- 
-- This programm converts simple ASCII graphics into crude Turtle-Images.
--
-- Try to convert your own ASCII graphics (or use some of the examples provided below.
--
-- Enjoy!
--
-- ->@ Disclaimer: @<-
--
-- Purely writen and tested on Windows 7 64-bit,
-- Using glut.dll for graphics.
--
-- ~~~/***** End of About *****\~~~



-- Import Turtle-Graphics environment (provided by UoE - Tutorial 7) and conversion functions (written by me)

import Ascii
import LSystem

-- ***********
-- Functions to display ASCII graphics
-- ***********

-- Function to print an ASCII as a Turtle Graphic (i.e. the main feat of this programm)
	
asciiToTurtle :: Ascii -> IO ()
asciiToTurtle a
	| legalAscii a
	= display (Turn 90 :#: drawLines (reverse a))
	| otherwise
	= error badAscii

-- Bonus: function to show an Ascii by printing it to the Terminal

asciiToTerminal :: Ascii -> IO ()
asciiToTerminal a
	| legalAscii a
	= putStr (unlines a)
	| otherwise
	= error badAscii



-- ***********
-- Some sample ASCII graphics for testing
-- ***********

-- More complex ASCII graphics (inspired by http://www.doghause.com/ascii.asp)

hedgehog :: Ascii
hedgehog =	[	"   |||||||||    ",
				" |||||||||||||  ",
				"|||||||||||  o\\ ",
				" ||||||||||____o"
			]

dinosaur :: Ascii
dinosaur =	[	"                __ ",
				"               /  )",
				"      _/\\/\\/\\_/ /  ",
				"    _|         /   ",
				"  _|  (  |  ( |    ",
				" /__.-'|_|--|_|    "
			]

smallbird :: Ascii
smallbird =	[	">o)",
				"(_>"
			]

fox :: Ascii
fox =	[	"   |\\/|     ____",
			"o__.. \\    /\\  /",
			" \\_   /___/  \\/ ",
			" _/   ___   _/  ",
			"/____/ ____/    "
		]
			
owl :: Ascii
owl =	[	"___/|",
			"\\o.0|",
			"(___)",
			"  U  "
		]
			
cat :: Ascii
cat = 	[	" /\\_/\\ ",
			"( o.o )",
			" > ^ < "
		]

dog :: Ascii
dog = 	[	"^..^      /",
			"/_/\\_____/ ",
			"   /\\   /\\ ",
			"  /  \\ /  \\"
		]

chicken :: Ascii
chicken =	[	"   \\\\ ",
				"   (o>",
				"\\\\_//)",
				" \\_/_)",
				"   |  ",
				"  _|_ "
			]
		
-- Very basic ASCII graphics for preliminary testing

badone :: Ascii
badone =	[	".....",
				".....",
				".....",
				"..."
			]
			
lamda :: Ascii
lamda =	[	"  \\    ",
			"   \\   ",
			"   /\\  ",
			"  /  \\ "
		]
